// This is a comment
// uncomment the line below if you want to write a filterscript
//#define FILTERSCRIPT

//#define _DEBUG 7

#define MODE_NAME AdminExample

//#define YSI_NO_X11

#include <streamer>
#include <YSI\y_groups>
#include <YSI\y_commands>
#include <YSI\y_users>
//#include <YSI\y_classes>
#include <YSI\y_uvar>
#include <YSI\y_svar>
#include <YSI>

#define MAX_ADMIN_LEVELS (6)

new
	Group:groupAdmins[MAX_ADMIN_LEVELS],
	gTestObject;

main()
{
	print("\n--------------------------------");
	print(" Example admin script by Y_Less ");
	print("--------------------------------\n");
}

YCMD:test(playerid, params[], help)
{
	printf("Has 0 %d: %d", gTestObject, Group_GetSObject(groupAdmins[0], gTestObject));
	printf("Has 1 %d: %d", gTestObject, Group_GetSObject(groupAdmins[1], gTestObject));
	printf("Has 2 %d: %d", gTestObject, Group_GetSObject(groupAdmins[2], gTestObject));
	printf("Has - %d: %d", gTestObject, Group_GetSObject(GROUP_GLOBAL, gTestObject));
	new
		players[MAX_PLAYERS];
	Streamer_GetArrayData(STREAMER_TYPE_OBJECT, gTestObject, E_STREAMER_PLAYER_ID, players, MAX_PLAYERS);
	for (new i = 0; i != MAX_PLAYERS; i += 10)
	{
		printf("%d %d %d %d %d %d %d %d %d %d", players[i + 0], players[i + 1], players[i + 2], players[i + 3],
			players[i + 4], players[i + 5], players[i + 6], players[i + 7], players[i + 8], players[i + 9]);
	}
	return 1;
}

YCMD:commands(playerid, params[], help)
{
	if (help)
	{
		SendClientMessage(playerid, 0xFF0000AA, "Lists all the commands a player can use.");
	}
	else
	{
		new
			count = Command_GetPlayerCommandCount(playerid);
		for (new i = 0; i != count; ++i)
		{
			SendClientMessage(playerid, 0xFF0000AA, Command_GetNext(i, playerid));
		}
	}
	return 1;
}

YCMD:help(playerid, params[], help)
{
	if (help)
	{
		SendClientMessage(playerid, 0xFF0000AA, "Displays help about your mode.");
	}
	else
	{
		if (isnull(params))
		{
			new
				str[128];
			SendClientMessage(playerid, 0xFF0000AA, "Welcome to my mode.");
			format(str, sizeof (str), "Type \"/%s [command]\" for more help on a command", Command_GetDisplay(YCMD:help, playerid));
			SendClientMessage(playerid, 0xFF0000AA, str);
		}
		else
		{
			Command_ReProcess(playerid, params, true);
		}
	}
	return 1;
}

YCMD:upgrade(playerid, params[], help)
{
	if (help)
	{
		SendClientMessage(playerid, 0xFF0000AA, "Increases your admin level by one.");
	}
	else
	{
		for (new i = 0; i != MAX_ADMIN_LEVELS; ++i)
		{
			if (!Group_GetPlayer(groupAdmins[i], playerid))
			{
				// Found the first admin level they aren't in.
				Group_SetPlayer(groupAdmins[i], playerid, true);
				return 1;
			}
		}
	}
	return 1;
}

public OnGameModeInit()
{
	Langs_Add("English", "EN");
	// Don't use these lines if it's a filterscript
	SetGameModeText("Example Admin Script");
	//Class_Add(0, -500.0, 2400.0, 20.0, 0.0);
	AddPlayerClass(0, -500.0, 2400.0, 20.0, 0.0, 0, 0, 0, 0, 0, 0);
	groupAdmins[0] = Group_Create("Admin Level 1");
	new
		gname[16];
	for (new i = 1; i != MAX_ADMIN_LEVELS; ++i)
	{
		format(gname, sizeof (gname), "Admin Level %d", i + 1);
		groupAdmins[i] = Group_Create(gname);
		// Create the hierarchy.
		Group_SetGroup(groupAdmins[i], groupAdmins[i - 1], true);
	}
	GROUP_ADD<groupAdmins[0]>
	{
		// http://forum.sa-mp.com/showthread.php?t=262472
		// Note that vehicles aren't actually streamed yet by any system
		// supported by y_groups, but I'll put this here anyway just so that
		// they COULD be.
		@YCMD:test;
		AddStaticVehicle(402,-482.6635,2563.1702,52.9885,85.5332,80,1); //
		AddStaticVehicle(603,-482.9032,2559.1765,53.0548,88.7433,80,1); //
		AddStaticVehicle(541,-530.4149,2568.5146,53.0524,268.7647,60,1); //
		AddStaticVehicle(411,-529.4701,2592.4624,53.1474,269.3027,106,1); //
		AddStaticVehicle(494,-528.9885,2616.2808,53.3095,269.4880,36,13); //
		AddStaticVehicle(568,-559.0512,2623.2170,53.3220,0.0163,17,1); //
		AddStaticVehicle(444,-553.1484,2624.2886,53.8686,359.5302,32,53); //
		AddStaticVehicle(522,-571.7362,2605.1941,65.4714,270.8058,8,82); //
		AddStaticVehicle(522,-571.8151,2582.1287,65.4697,266.1711,7,79); //
		AddStaticVehicle(425,-567.6856,2593.8413,66.4471,269.5215,43,0); //
		AddStaticVehicle(432,-554.4165,2560.8384,53.4915,178.9395,43,0); //
		AddStaticVehicle(470,-559.4370,2562.5676,53.4234,178.8594,43,0); //
		AddStaticVehicle(433,-563.5087,2560.5342,53.8342,180.4832,43,0); //
		gTestObject = CreateDynamicObject(16258,-470.99987800,2567.45214800,47.30867000,0.00000000,0.00000000,91.95972612, .streamdistance = 500.0); //object(1)
		CreateDynamicObject(10828,-566.51446500,2605.62988300,87.76288600,-90.24085273,0.00000000,0.00000000, .streamdistance = 500.0); //aircraft door 2
		CreateDynamicObject(10828,-566.52624500,2581.02783200,87.95216400,-270.72255820,0.00000000,0.00000000, .streamdistance = 500.0); //aircraft door 1
		CreateDynamicObject(16667,-451.39913900,2548.01171900,50.99629600,20.62648062,9.45380362,112.58609215, .streamdistance = 500.0); //object(19)
		CreateDynamicObject(3330,-557.97137500,2577.09399400,80.13223300,0.00000000,0.00000000,0.00000000, .streamdistance = 500.0); //object(37)
		CreateDynamicObject(3330,-575.48590100,2576.92358400,80.09264400,0.00000000,0.00000000,0.00000000, .streamdistance = 500.0); //object(38)
		CreateDynamicObject(3330,-575.42889400,2609.86084000,80.13641400,0.00000000,0.00000000,0.00000000, .streamdistance = 500.0); //object(41)
		CreateDynamicObject(3330,-584.29931600,2585.72119100,80.17540700,0.00000000,0.00000000,89.38141604, .streamdistance = 500.0); //object(42)
		CreateDynamicObject(3330,-584.05725100,2600.94970700,80.10040300,0.00000000,0.00000000,89.38135874, .streamdistance = 500.0); //object(44)
		CreateDynamicObject(16147,-517.92620800,2679.47973600,57.12531300,-0.85943669,0.00000000,47.26896080, .streamdistance = 500.0); //object(55)
		CreateDynamicObject(9209,-516.19091800,2673.35791000,19.69976200,-1.71887339,-136.65049143,124.61832044, .streamdistance = 500.0); //object(73)
		CreateDynamicObject(3755,-530.90063500,2592.94043000,57.81347700,0.00000000,0.00000000,89.38141604, .streamdistance = 500.0); //object(82)
		CreateDynamicObject(16682,-459.37860100,2593.57861300,48.28169300,45.55008742,-98.83521966,186.49787691, .streamdistance = 500.0); //object(19)
		CreateDynamicObject(10841,-461.03149400,2593.15234400,56.66737400,6.01605685,0.00000000,90.24073814, .streamdistance = 500.0); //garage door
		CreateDynamicObject(2774,-454.23266600,2588.26123000,41.72175600,0.00000000,6.87549354,0.00000000, .streamdistance = 500.0); //object(21)
		CreateDynamicObject(2774,-454.19757100,2598.19677700,41.81879400,0.00000000,6.01605685,0.00000000, .streamdistance = 500.0); //object(22)
		CreateDynamicObject(2774,-452.79040500,2596.27075200,53.62374100,92.81910552,-76.48980835,76.48980835, .streamdistance = 500.0); //object(23)
		CreateDynamicObject(16112,-450.67269900,2618.90771500,62.79818700,5.15662016,96.25685229,-0.85943669, .streamdistance = 500.0); //object(25)
		CreateDynamicObject(16121,-447.48529100,2567.47021500,43.21579700,-8.59436693,4.29718346,-6.01605685, .streamdistance = 500.0); //object(26)
		CreateDynamicObject(16113,-569.30590800,2617.24072300,85.83120000,-12.03211370,7.73493023,45.55014471, .streamdistance = 500.0); //object(24)
		CreateDynamicObject(16113,-565.52752700,2569.35278300,87.18934600,0.00000000,0.00000000,-137.50992813, .streamdistance = 500.0); //object(25)
		CreateDynamicObject(16113,-591.91320800,2587.59472700,82.14628600,0.00000000,0.00000000,134.07218136, .streamdistance = 500.0); //object(26)
		CreateDynamicObject(2774,-549.02655000,2603.40893600,88.85580400,89.38135874,0.00000000,0.00000000, .streamdistance = 500.0); //object(27)
		CreateDynamicObject(2774,-549.02728300,2585.54858400,89.06871000,89.38135874,0.00000000,0.00000000, .streamdistance = 500.0); //object(28)
		CreateDynamicObject(2774,-549.04498300,2585.51538100,87.51695300,89.38135874,0.00000000,0.00000000, .streamdistance = 500.0); //object(29)
		CreateDynamicObject(2774,-549.03179900,2603.36938500,87.31139400,89.38135874,0.00000000,0.00000000, .streamdistance = 500.0); //object(30)
		CreateDynamicObject(2600,-458.44326800,2602.54101600,51.18835400,0.00000000,0.00000000,359.24453755, .streamdistance = 500.0); //object(33)
		CreateDynamicObject(16133,-431.23440600,2612.45922900,43.70317100,7.73493023,0.00000000,80.78704911, .streamdistance = 500.0); //object(32)
		CreateDynamicObject(16122,-502.47146600,2673.40234400,47.42462900,0.00000000,0.00000000,97.11640357, .streamdistance = 500.0); //object(33)
		CreateDynamicObject(16168,-642.81073000,2585.51318400,51.70522300,0.00000000,-8.59436693,-178.76329045, .streamdistance = 500.0); //object(36)
		CreateDynamicObject(16169,-568.13665800,2522.17504900,41.29841600,0.00000000,0.00000000,-28.36141086, .streamdistance = 500.0); //object(37)
		CreateDynamicObject(16170,-498.95935100,2565.18286100,74.80117000,-0.85943669,2.57831008,75.63042896, .streamdistance = 500.0); //object(38)
		CreateDynamicObject(16110,-471.35760500,2485.30566400,50.89123500,0.00000000,0.00000000,-79.06823302, .streamdistance = 500.0); //object(40)
		CreateDynamicObject(16112,-470.27847300,2499.54150400,76.64655300,0.00000000,91.95966882,-87.66248536, .streamdistance = 500.0); //object(41)
		CreateDynamicObject(16113,-482.23919700,2490.94628900,44.52908300,0.00000000,0.00000000,210.56216160, .streamdistance = 500.0); //object(42)
		CreateDynamicObject(16264,-437.87149000,2606.74707000,74.21315800,20.62648062,0.00000000,99.69465635, .streamdistance = 500.0); //object(49)
		CreateDynamicObject(16667,-443.70770300,2550.80297900,63.60937500,21.48591732,14.61042378,71.33324549, .streamdistance = 500.0); //object(55)
		CreateDynamicObject(16667,-432.31430100,2566.19018600,49.49454500,10.31324031,23.20479070,85.08423258, .streamdistance = 500.0); //object(56)
		CreateDynamicObject(16675,-416.26516700,2526.20092800,39.60248600,11.17267701,12.89155039,23.20479070, .streamdistance = 500.0); //object(57)
		CreateDynamicObject(16139,-442.75631700,2562.61303700,56.11395300,41.25296125,30.08028424,52.42563825, .streamdistance = 500.0); //object(60)
		CreateDynamicObject(9209,-465.71389800,2638.85424800,21.64292900,-12.89155039,-125.47775713,68.75493542, .streamdistance = 500.0); //object(62)
		CreateDynamicObject(16121,-463.87963900,2531.45483400,91.71708700,-23.20479070,63.59825796,-21.48591732, .streamdistance = 500.0); //object(63)
		CreateDynamicObject(16121,-468.22460900,2515.83496100,90.76698300,0.00000000,0.00000000,-182.20080803, .streamdistance = 500.0); //object(64)
		CreateDynamicObject(17030,-475.95449800,2622.69799800,50.32613400,0.00000000,-0.85943669,182.20063615, .streamdistance = 500.0); //object(70)
		CreateDynamicObject(9241,-566.75299100,2593.54345700,64.07067100,0.00000000,0.00000000,179.62232607, .streamdistance = 500.0); //object(52)
		CreateDynamicObject(2774,-462.24792500,2585.42749000,48.19706000,0.00000000,5.15662016,0.00000000, .streamdistance = 500.0); //object(55)
		CreateDynamicObject(2774,-461.62783800,2593.30981400,57.28272200,90.24085273,-693.56426509,334.42440693, .streamdistance = 500.0); //object(56)
		CreateDynamicObject(2774,-462.37112400,2600.98779300,48.53492700,0.00000000,5.15662016,0.00000000, .streamdistance = 500.0); //object(57)
		CreateDynamicObject(2774,-463.77050800,2602.61352500,48.68030500,0.00000000,5.15662016,0.00000000, .streamdistance = 500.0); //object(58)
		CreateDynamicObject(2774,-463.25982700,2583.92993200,48.27013400,0.00000000,5.15662016,0.00000000, .streamdistance = 500.0); //object(59)
		CreateDynamicObject(2774,-461.79861500,2585.75561500,55.75257100,-39.53408786,5.15662016,0.00000000, .streamdistance = 500.0); //object(61)
		CreateDynamicObject(2774,-462.01834100,2601.07959000,55.43718000,43.83127133,5.15662016,0.00000000, .streamdistance = 500.0); //object(62)
		CreateDynamicObject(16264,-583.69012500,2521.10376000,82.01680800,-1.71887339,14.61042378,-46.40958141, .streamdistance = 500.0); //object(63)
		CreateDynamicObject(9209,-480.54376200,2556.61279300,25.86644000,4.29718346,-96.25685229,19.76710123, .streamdistance = 500.0); //object(65)
		CreateDynamicObject(9209,-491.22625700,2576.56591800,68.65145100,-111.72671275,-12.03211370,90.24085273, .streamdistance = 500.0); //object(66)
		CreateDynamicObject(16114,-502.72955300,2502.95922900,64.51923400,-0.85943669,30.08028424,-91.95972612, .streamdistance = 500.0); //object(68)
		CreateDynamicObject(9209,-499.79083300,2536.19848600,18.93325400,-8.59436693,-96.25685229,-11.17261971, .streamdistance = 500.0); //object(69)
		CreateDynamicObject(9209,-536.27063000,2525.91894500,30.03440900,-5.15662016,-115.16445953,-72.19262489, .streamdistance = 500.0); //object(73)
		CreateDynamicObject(18228,-509.35723900,2524.58325200,50.69427900,0.00000000,0.00000000,-16.32929716, .streamdistance = 500.0); //object(75)
		CreateDynamicObject(16667,-575.62390100,2528.66723600,93.57142600,58.44169510,0.00000000,-44.69070802, .streamdistance = 500.0); //object(76)
		CreateDynamicObject(9209,-517.97241200,2581.93823200,81.11983500,-37.81521448,-187.35719901,91.10023213, .streamdistance = 500.0); //object(77)
		CreateDynamicObject(2774,-547.55926500,2589.57470700,88.89167000,89.38135874,0.00000000,0.00000000, .streamdistance = 500.0); //object(78)
		CreateDynamicObject(9209,-563.34539800,2637.36035200,72.96159400,-21.48591732,-189.07607239,180.48204924, .streamdistance = 500.0); //object(79)
		CreateDynamicObject(9209,-546.24652100,2550.19165000,74.17461400,-65.31713135,-192.51381916,180.48204924, .streamdistance = 500.0); //object(82)
		CreateDynamicObject(9209,-567.92718500,2548.04956100,21.11651600,-5.15662016,-110.00783937,-99.69465635, .streamdistance = 500.0); //object(84)
		CreateDynamicObject(16112,-569.31054700,2549.74511700,98.78678100,-7.73493023,6.87549354,-22.34529671, .streamdistance = 500.0); //object(70)
		CreateDynamicObject(16112,-572.28234900,2529.31469700,95.38534500,0.00000000,85.94366927,-140.08829550, .streamdistance = 500.0); //object(71)
		CreateDynamicObject(1305,-515.53466800,2507.17431600,84.22605900,0.00000000,0.00000000,0.00000000, .streamdistance = 500.0); //object(75)
		CreateDynamicObject(1305,-514.78271500,2508.86914100,84.93320500,0.00000000,0.00000000,77.34930234, .streamdistance = 500.0); //object(77)
		CreateDynamicObject(16110,-589.39471400,2552.30127000,91.05395500,0.85943669,24.92366409,193.37325586, .streamdistance = 500.0); //object(79)
		CreateDynamicObject(16113,-597.53533900,2595.21460000,94.58388500,-24.92366409,63.59831526,-33.41415377, .streamdistance = 500.0); //object(81)
		CreateDynamicObject(16113,-596.50549300,2610.73925800,85.24502600,0.00000000,0.00000000,96.25690958, .streamdistance = 500.0); //object(82)
		CreateDynamicObject(16113,-572.74939000,2630.28881800,84.11034400,-14.61042378,0.00000000,24.06422740, .streamdistance = 500.0); //object(83)
		CreateDynamicObject(2774,-545.88226300,2588.05444300,88.71835300,89.38135874,0.00000000,0.00000000, .streamdistance = 500.0); //object(84)
		CreateDynamicObject(16112,-623.41607700,2592.60986300,72.33894300,0.00000000,-51.56620156,-1.71887339, .streamdistance = 500.0); //object(85)
		CreateDynamicObject(11556,-604.50952100,2555.97192400,100.00123600,0.00000000,0.00000000,278.45777491, .streamdistance = 500.0); //object(87)
		CreateDynamicObject(16112,-468.64877300,2545.24243200,92.21420300,0.00000000,5.15662016,101.41352974, .streamdistance = 500.0); //object(88)
		CreateDynamicObject(16118,-453.87933300,2549.23730500,85.23977700,-1.71887339,55.00394833,-18.90760724, .streamdistance = 500.0); //object(91)
		CreateDynamicObject(16121,-451.94253500,2640.95336900,95.17684900,0.00000000,0.00000000,0.00000000, .streamdistance = 500.0); //object(93)
		CreateDynamicObject(17054,-442.51809700,2604.63256800,51.20267500,62.73887857,0.00000000,1.71887339, .streamdistance = 500.0); //object(112)
		CreateDynamicObject(17054,-442.90673800,2581.65893600,49.20578800,-57.58225841,0.00000000,0.00000000, .streamdistance = 500.0); //object(113)
		CreateDynamicObject(16134,-434.81314100,2609.80102500,48.95566900,0.00000000,-79.06817573,-179.62215418, .streamdistance = 500.0); //object(118)
		CreateDynamicObject(17054,-443.16284200,2594.42993200,61.33572400,211.42154099,-2.57831008,-4.29718346, .streamdistance = 500.0); //object(120)
		CreateDynamicObject(16112,-429.40518200,2609.14648400,54.03715900,4.29718346,93.67865680,-82.50592250, .streamdistance = 500.0); //object(90)
		CreateDynamicObject(16112,-424.31369000,2625.99829100,56.39120100,0.00000000,88.52197935,34.37746771, .streamdistance = 500.0); //object(91)
		CreateDynamicObject(16112,-430.17843600,2616.36694300,61.51936300,0.00000000,0.00000000,141.80711159, .streamdistance = 500.0); //object(92)
		CreateDynamicObject(1304,-431.31665000,2596.50439500,54.92606000,0.00000000,0.00000000,0.00000000, .streamdistance = 500.0); //object(99)
		CreateDynamicObject(11556,-463.21255500,2594.69140600,72.38448300,-17.18873385,-177.90339539,279.31692513, .streamdistance = 500.0); //object(101)
		CreateDynamicObject(11556,-462.96441700,2596.92749000,71.54097000,-14.61042378,-188.21675029,251.81518014, .streamdistance = 500.0); //object(103)
		CreateDynamicObject(1305,-434.12048300,2595.69116200,61.47518900,0.00000000,0.00000000,0.00000000, .streamdistance = 500.0); //object(104)
		CreateDynamicObject(1305,-434.40621900,2598.20825200,62.30279500,0.00000000,42.97183463,-83.36535919, .streamdistance = 500.0); //object(105)
		CreateDynamicObject(1305,-431.57391400,2588.05102500,58.42812000,0.00000000,0.00000000,84.22479588, .streamdistance = 500.0); //object(106)
		CreateDynamicObject(1304,-433.79617300,2596.99316400,61.42892500,0.00000000,0.00000000,0.00000000, .streamdistance = 500.0); //object(107)
		CreateDynamicObject(16112,-435.09930400,2607.27807600,82.07009100,32.65859432,96.25690958,-34.37746771, .streamdistance = 500.0); //object(109)
		CreateDynamicObject(11556,-444.09909100,2588.35083000,51.38697400,0.00000000,0.00000000,181.34137134, .streamdistance = 500.0); //object(110)
		CreateDynamicObject(16116,-448.60363800,2581.25659200,85.45578800,14.61042378,-31.79915763,171.88773961, .streamdistance = 500.0); //object(113)
		CreateDynamicObject(16116,-473.12323000,2591.88916000,87.19397700,0.00000000,0.00000000,126.33713653, .streamdistance = 500.0); //object(115)
		CreateDynamicObject(896,-465.17718500,2572.99072300,53.81236300,0.00000000,4.29718346,-53.28501765, .streamdistance = 500.0); //object(116)
		CreateDynamicObject(896,-475.46542400,2615.50732400,56.55288700,0.00000000,0.00000000,0.00000000, .streamdistance = 500.0); //object(117)
		CreateDynamicObject(16120,-575.59094200,2546.08032200,99.99838300,3.43774677,0.00000000,0.00000000, .streamdistance = 500.0); //object(110)
		CreateDynamicObject(16112,-584.07489000,2539.26733400,93.02586400,-2.57831008,63.59831526,221.73478131, .streamdistance = 500.0); //object(111)
		CreateDynamicObject(16112,-599.63537600,2557.54760700,90.64746100,0.00000000,77.34930234,-163.29302891, .streamdistance = 500.0); //object(112)
		CreateDynamicObject(2634,-459.68643200,2602.17138700,51.65377400,-0.85943669,-6.87549354,184.77894623, .streamdistance = 500.0); //object(111)
		CreateDynamicObject(3264,-424.27978500,2598.61279300,43.13153500,0.00000000,0.00000000,83.36535919, .streamdistance = 500.0); //object(112)
		CreateDynamicObject(3263,-396.34759500,2579.18994100,40.26143300,0.00000000,0.00000000,60.16051119, .streamdistance = 500.0); //object(114)
		CreateDynamicObject(2921,-452.01480100,2589.54418900,53.27885400,0.00000000,0.00000000,-127.19663052, .streamdistance = 500.0); //object(148)
		CreateDynamicObject(2922,-458.37756300,2602.09668000,51.80014000,0.00000000,0.00000000,181.34119945, .streamdistance = 500.0); //object(149)
		CreateDynamicObject(5822,-549.89105200,2551.24804700,59.48858600,0.00000000,0.00000000,93.67859950, .streamdistance = 500.0); //object(120)
		CreateDynamicObject(16093,-544.64257800,2593.77294900,56.36830900,0.00000000,0.00000000,90.24085273, .streamdistance = 500.0); //object(115)
		CreateDynamicObject(16782,-544.62475600,2593.59277300,57.62957800,0.00000000,0.00000000,179.62221148, .streamdistance = 500.0); //object(116)
		CreateDynamicObject(744,-618.91503900,2668.48486300,73.07263900,0.00000000,0.00000000,0.00000000, .streamdistance = 500.0); //object(117)
		CreateDynamicObject(16133,-594.00781300,2588.57983400,94.03559100,0.00000000,-29.22084755,0.85943669, .streamdistance = 500.0); //object(118)
		CreateDynamicObject(8947,-555.80548100,2622.02075200,55.54340400,0.00000000,0.00000000,177.90350998, .streamdistance = 500.0); //object(161)
		CreateDynamicObject(8947,-555.91015600,2621.99438500,61.56340000,0.00000000,0.00000000,-2.47494849, .streamdistance = 500.0); //object(163)
		CreateDynamicObject(13753,-584.06500200,2628.90551800,65.51155100,0.00000000,0.00000000,87.66248536, .streamdistance = 500.0); //object(177)
		CreateDynamicObject(900,-585.07458500,2624.08178700,71.59023300,39.53408786,87.66248536,10.31324031, .streamdistance = 500.0); //object(179)
		CreateDynamicObject(896,-579.28967300,2640.61669900,72.27272000,0.00000000,0.00000000,0.00000000, .streamdistance = 500.0); //object(183)
		CreateDynamicObject(896,-582.38507100,2634.62622100,70.03068500,0.00000000,0.00000000,87.66248536, .streamdistance = 500.0); //object(186)
		CreateDynamicObject(901,-524.72412100,2659.14697300,56.41933800,0.00000000,0.00000000,0.00000000, .streamdistance = 500.0); //object(189)
		CreateDynamicObject(3850,-562.69836400,2634.63256800,65.25006900,0.00000000,0.00000000,-2.57831008, .streamdistance = 500.0); //object(190)
		CreateDynamicObject(3850,-562.56665000,2638.08837900,65.24168400,0.00000000,0.00000000,-2.57831008, .streamdistance = 500.0); //object(192)
		CreateDynamicObject(8947,-569.72290000,2642.56372100,61.56955700,0.00000000,0.00000000,-2.47494849, .streamdistance = 500.0); //object(198)
		CreateDynamicObject(3268,-563.92169200,2562.38330100,52.51562500,0.00000000,0.00000000,89.38135874, .streamdistance = 500.0); //object(136)
		CreateDynamicObject(11493,-540.96368400,2650.37817400,57.94994400,0.00000000,0.00000000,116.88333291, .streamdistance = 500.0); //object(163)
		CreateDynamicObject(899,-562.09155300,2643.44848600,49.75362800,-51.56614427,91.95966882,-27.50197417, .streamdistance = 500.0); //object(173)
		CreateDynamicObject(900,-555.31695600,2653.26196300,53.79200700,0.00000000,0.00000000,0.00000000, .streamdistance = 500.0); //object(174)
		CreateDynamicObject(900,-545.18182400,2658.04467800,52.62428300,182.20063615,14.61042378,206.26492084, .streamdistance = 500.0); //object(175)
		CreateDynamicObject(901,-555.35955800,2649.49023400,56.80614900,0.00000000,0.00000000,0.00000000, .streamdistance = 500.0); //object(176)
		CreateDynamicObject(896,-543.40087900,2653.79541000,50.24632300,-36.95577779,127.19663052,69.61431481, .streamdistance = 500.0); //object(179)
		CreateDynamicObject(897,-549.59625200,2649.48242200,54.48804500,0.00000000,-30.93972094,0.00000000, .streamdistance = 500.0); //object(180)
		CreateDynamicObject(901,-547.51397700,2652.38842800,54.38015000,-70.47375151,-18.90760724,-18.04817055, .streamdistance = 500.0); //object(182)
		CreateDynamicObject(906,-548.76525900,2649.88769500,58.09550500,0.00000000,0.00000000,-34.37746771, .streamdistance = 500.0); //object(183)
		CreateDynamicObject(906,-543.23999000,2649.01269500,58.45158800,0.00000000,97.97572567,118.60220630, .streamdistance = 500.0); //object(185)
		CreateDynamicObject(906,-557.97387700,2645.34448200,62.15214900,-10.31324031,43.83127133,19.76704393, .streamdistance = 500.0); //object(186)
		CreateDynamicObject(880,-561.63494900,2640.97094700,62.60586500,0.00000000,0.00000000,50.70670757, .streamdistance = 500.0); //object(187)
		CreateDynamicObject(896,-564.09625200,2642.61474600,56.99940500,0.00000000,0.00000000,0.00000000, .streamdistance = 500.0); //object(189)
		CreateDynamicObject(880,-557.25122100,2646.45312500,59.62146000,106.57003530,0.00000000,-140.08835280, .streamdistance = 500.0); //object(191)
		CreateDynamicObject(3361,-523.33972200,2649.83935500,53.01455700,0.00000000,0.00000000,-22.34535401, .streamdistance = 500.0); //object(192)
		CreateDynamicObject(3631,-536.60900900,2651.86962900,52.22137500,90.24079544,0.00000000,21.48591732, .streamdistance = 500.0); //object(202)
		CreateDynamicObject(3461,-534.63690200,2651.82202100,56.25561100,0.00000000,0.00000000,0.00000000, .streamdistance = 500.0); //object(211)
		CreateDynamicObject(900,-542.70092800,2656.68750000,60.22381200,87.66248536,26.64253747,157.27708665, .streamdistance = 500.0); //object(213)
		CreateDynamicObject(901,-556.65985100,2651.52002000,66.41058300,282.75490108,32.65859432,52.42558096, .streamdistance = 500.0); //object(214)
		CreateDynamicObject(898,-566.60449200,2650.34814500,68.60862000,65.31713135,0.00000000,10.31324031, .streamdistance = 500.0); //object(215)
		CreateDynamicObject(897,-575.64794900,2645.53125000,69.20352900,0.00000000,0.00000000,0.00000000, .streamdistance = 500.0); //object(216)
		CreateDynamicObject(897,-537.04577600,2651.50488300,49.70534100,0.00000000,-11.17267701,48.98783419, .streamdistance = 500.0); //object(217)
		CreateDynamicObject(2395,-529.13629200,2651.07641600,52.39061700,0.00000000,0.00000000,-22.34535401, .streamdistance = 500.0); //object(221)
		CreateDynamicObject(2395,-532.48693800,2652.45385700,52.39061700,0.00000000,0.00000000,-22.34535401, .streamdistance = 500.0); //object(222)
		CreateDynamicObject(2395,-534.59326200,2651.87329100,52.39061700,0.00000000,0.00000000,21.48591732, .streamdistance = 500.0); //object(223)
		CreateDynamicObject(2395,-525.99371300,2650.46484400,52.36561600,0.00000000,0.00000000,70.47375151, .streamdistance = 500.0); //object(224)
		CreateDynamicObject(2395,-524.68579100,2653.76538100,52.39061700,0.00000000,0.00000000,46.40952411, .streamdistance = 500.0); //object(225)
		CreateDynamicObject(899,-519.91229200,2663.46411100,49.63332400,0.00000000,0.00000000,0.00000000, .streamdistance = 500.0); //object(226)
		CreateDynamicObject(3850,-562.41424600,2641.49926800,65.25115200,0.00000000,0.00000000,-2.57831008, .streamdistance = 500.0); //object(227)
		CreateDynamicObject(1497,-551.42102100,2572.13061500,52.50504700,0.00000000,0.00000000,0.00000000, .streamdistance = 500.0); //object(248)
		CreateDynamicObject(1497,-577.79620400,2572.41894500,52.50365800,0.00000000,0.00000000,0.00000000, .streamdistance = 500.0); //object(249)
		CreateDynamicObject(1497,-549.08783000,2556.24438500,52.55471800,0.00000000,0.00000000,267.28475413, .streamdistance = 500.0); //object(250)
		CreateDynamicObject(1815,-577.52502400,2615.10913100,64.70333900,0.00000000,0.00000000,0.00000000, .streamdistance = 500.0); //object(251)
		CreateDynamicObject(11334,-576.85119600,2615.20971700,65.47769900,0.00000000,0.00000000,0.00000000, .streamdistance = 500.0); //object(254)
		CreateDynamicObject(1792,-575.12439000,2617.47583000,65.24491100,0.00000000,0.00000000,-55.00389104, .streamdistance = 500.0); //object(256)
		CreateDynamicObject(1575,-577.05889900,2615.44628900,65.15219900,0.00000000,0.00000000,0.00000000, .streamdistance = 500.0); //object(270)
		CreateDynamicObject(1575,-577.32305900,2615.69555700,65.25220500,0.00000000,-30.93972094,-94.53797890, .streamdistance = 500.0); //object(271)
		CreateDynamicObject(2344,-575.29669200,2617.04663100,66.15087100,-25.78310078,22.34535401,-20.62648062, .streamdistance = 500.0); //object(303)
		CreateDynamicObject(16151,-576.02191200,2622.61718800,65.09591700,0.00000000,0.00000000,86.80304867, .streamdistance = 500.0); //object(311)
		CreateDynamicObject(4724,-578.40136700,2629.69091800,66.75325000,0.00000000,0.00000000,177.90333809, .streamdistance = 500.0); //object(313)
		CreateDynamicObject(4724,-578.41564900,2629.75268600,66.48112500,0.00000000,0.00000000,177.90333809, .streamdistance = 500.0); //object(316)
		CreateDynamicObject(3461,-545.87310800,2649.18115200,62.12339000,0.00000000,0.00000000,0.00000000, .streamdistance = 500.0); //object(328)
		CreateDynamicObject(3461,-559.79064900,2644.68066400,64.85031900,0.00000000,0.00000000,0.00000000, .streamdistance = 500.0); //object(329)
		CreateDynamicObject(1550,-577.13269000,2616.39306600,65.09750400,0.00000000,0.00000000,0.00000000, .streamdistance = 500.0); //object(345)
		CreateDynamicObject(16112,-442.38696300,2614.02734400,92.93664600,0.00000000,0.00000000,152.97996048, .streamdistance = 500.0); //object(346)
		CreateDynamicObject(16112,-443.38934300,2573.03784200,77.72253400,91.10023213,5.15662016,94.53803620, .streamdistance = 500.0); //object(347)
		CreateDynamicObject(16112,-537.45440700,2560.02221700,88.77065300,0.00000000,0.00000000,20.62648062, .streamdistance = 500.0); //object(348)
		CreateDynamicObject(2395,-564.82690400,2646.64111300,64.85417200,-91.10023213,0.00000000,266.42571851, .streamdistance = 500.0); //object(173)
		CreateDynamicObject(9093,-555.36798100,2633.97363300,55.96125800,0.00000000,90.24079544,88.52192205, .streamdistance = 500.0); //static garage door
		CreateDynamicObject(1895,-561.03125000,2613.67627000,53.82689300,1.71887339,-43.83127133,180.48164817, .streamdistance = 500.0); //object(181)
		CreateDynamicObject(2907,-561.08691400,2613.63793900,53.96286000,-92.81910552,0.00000000,0.00000000, .streamdistance = 500.0); //object(184)
		CreateDynamicObject(2906,-561.37634300,2613.72485400,54.34998300,40.39346726,-191.65495543,73.91149828, .streamdistance = 500.0); //object(185)
		CreateDynamicObject(2906,-560.75878900,2613.69677700,54.32602700,42.97183463,6.01605685,-83.36530190, .streamdistance = 500.0); //object(186)
		CreateDynamicObject(2908,-561.04736300,2613.75488300,54.48092700,-91.10023213,96.25685229,-7.73493023, .streamdistance = 500.0); //object(187)
		CreateDynamicObject(2905,-560.83886700,2613.64453100,53.24757400,-73.91149828,-353.22739208,-110.86721877, .streamdistance = 500.0); //object(188)
		CreateDynamicObject(2905,-562.70288100,2613.82910200,53.73214300,132.35336527,-84.22473859,147.82322574, .streamdistance = 500.0); //object(189)
		CreateDynamicObject(1264,-562.47631800,2613.82788100,52.98777000,0.00000000,0.00000000,0.00000000, .streamdistance = 500.0); //object(190)
		CreateDynamicObject(1265,-562.44268800,2614.54565400,52.98466900,0.00000000,0.00000000,0.00000000, .streamdistance = 500.0); //object(191)
		CreateDynamicObject(1264,-562.41564900,2613.96362300,53.59520000,0.00000000,0.00000000,0.00000000, .streamdistance = 500.0); //object(192)
		CreateDynamicObject(2906,-562.23992900,2613.97778300,52.87077000,0.00000000,0.00000000,-64.45769466, .streamdistance = 500.0); //object(196)
		CreateDynamicObject(2907,-562.32605000,2614.65234400,53.20481900,220.01607981,177.90345268,-30.93972094, .streamdistance = 500.0); //object(197)
		CreateDynamicObject(2908,-562.18096900,2614.95752000,53.53712100,-26.64253747,66.17656804,184.77906082, .streamdistance = 500.0); //object(198)
		CreateDynamicObject(941,-560.47198500,2615.88330100,52.99033700,0.00000000,0.00000000,90.24079544, .streamdistance = 500.0); //object(187)
		CreateDynamicObject(2905,-560.43762200,2616.22924800,53.55732300,0.00000000,0.00000000,198.53033438, .streamdistance = 500.0); //object(188)
		CreateDynamicObject(934,-549.95605500,2616.00561500,53.84390300,0.00000000,0.00000000,0.00000000, .streamdistance = 500.0); //object(191)
		CreateDynamicObject(2358,-575.68585200,2613.36474600,64.77069900,0.00000000,0.00000000,161.57444200, .streamdistance = 500.0); //object(192)
		CreateDynamicObject(2358,-576.34967000,2613.85400400,64.79570000,0.00000000,0.00000000,106.57014989, .streamdistance = 500.0); //object(194)
		CreateDynamicObject(2359,-576.24133300,2613.55664100,65.10876500,-0.85943669,-0.85943669,123.75882645, .streamdistance = 500.0); //object(196)
		CreateDynamicObject(2669,-561.37512200,2616.12573200,53.83333600,0.00000000,0.00000000,179.62249796, .streamdistance = 500.0); //object(197)
		CreateDynamicObject(2678,-560.59265100,2618.77978500,53.69991300,0.00000000,0.00000000,110.00778207, .streamdistance = 500.0); //object(198)
		CreateDynamicObject(2679,-562.11132800,2618.86914100,53.69991300,0.00000000,0.00000000,318.85049733, .streamdistance = 500.0); //object(199)
		CreateDynamicObject(3576,-557.99926800,2614.96728500,54.00829700,0.00000000,0.00000000,-87.66248536, .streamdistance = 500.0); //object(201)
		CreateDynamicObject(3577,-561.27990700,2616.23681600,55.96537000,0.00000000,0.00000000,0.00000000, .streamdistance = 500.0); //object(202)
		CreateDynamicObject(3633,-555.69128400,2614.23779300,52.99042500,0.00000000,0.00000000,0.00000000, .streamdistance = 500.0); //object(203)
		CreateDynamicObject(958,-552.58569300,2614.25805700,53.39246400,0.00000000,0.00000000,0.00000000, .streamdistance = 500.0); //object(205)
		CreateDynamicObject(959,-552.58898900,2614.26464800,53.43158300,0.00000000,0.00000000,0.00000000, .streamdistance = 500.0); //object(206)
		CreateDynamicObject(14651,-559.32598900,2617.76489300,66.85840600,0.00000000,0.00000000,0.00000000, .streamdistance = 500.0); //pooltable
		CreateDynamicObject(2044,-576.05780000,2613.40869100,65.08892100,0.00000000,0.00000000,97.97572567, .streamdistance = 500.0); //object(224)
		CreateDynamicObject(2044,-576.13989300,2613.55639600,65.11593600,-2.57831008,9.45380362,92.81910552, .streamdistance = 500.0); //object(225)
		CreateDynamicObject(2228,-562.57507300,2615.38989300,53.17163500,17.18873385,0.00000000,-84.22473859, .streamdistance = 500.0); //object(228)
		CreateDynamicObject(1515,-554.32141100,2613.97680700,52.55120800,0.00000000,0.00000000,179.62244066, .streamdistance = 500.0); //object(237)
		CreateDynamicObject(1978,-552.45166000,2619.04199200,65.66756400,0.00000000,0.00000000,89.38135874, .streamdistance = 500.0); //object(239)
		CreateDynamicObject(2188,-556.97961400,2621.96972700,65.62103300,0.00000000,0.00000000,0.00000000, .streamdistance = 500.0); //object(240)
		CreateDynamicObject(1716,-555.26123000,2621.70190400,64.63539900,0.00000000,0.00000000,0.00000000, .streamdistance = 500.0); //object(241)
		CreateDynamicObject(1716,-555.66143800,2621.23657200,64.65797400,0.00000000,0.00000000,0.00000000, .streamdistance = 500.0); //object(242)
		CreateDynamicObject(1716,-556.15344200,2620.86499000,64.67960400,0.00000000,0.00000000,0.00000000, .streamdistance = 500.0); //object(243)
		CreateDynamicObject(1716,-556.65368700,2620.84033200,64.65966800,0.00000000,0.00000000,0.00000000, .streamdistance = 500.0); //object(244)
		CreateDynamicObject(1716,-557.11480700,2621.02710000,64.63539900,0.00000000,0.00000000,0.00000000, .streamdistance = 500.0); //object(245)
		CreateDynamicObject(1716,-557.58190900,2621.24316400,64.66040000,0.00000000,0.00000000,0.00000000, .streamdistance = 500.0); //object(246)
		CreateDynamicObject(1716,-557.93957500,2621.75463900,64.63539900,0.00000000,0.00000000,0.00000000, .streamdistance = 500.0); //object(247)
		CreateDynamicObject(1979,-553.79266400,2618.90966800,65.63466600,0.00000000,0.00000000,0.00000000, .streamdistance = 500.0); //object(254)
		CreateDynamicObject(1829,-579.28436300,2617.00976600,65.16869400,0.00000000,0.00000000,91.95966882, .streamdistance = 500.0); //object(258)
		CreateDynamicObject(14447,-559.68573000,2616.54321300,69.41612200,0.00000000,0.00000000,177.90328080, .streamdistance = 500.0); //object(249)
		CreateDynamicObject(3330,-558.04315200,2609.96142600,80.12461100,0.00000000,0.00000000,0.00000000, .streamdistance = 500.0); //object(250)
		CreateDynamicObject(4724,-561.89007600,2620.99169900,66.88114900,0.00000000,0.00000000,177.90373916, .streamdistance = 500.0); //object(235)
		CreateDynamicObject(2395,-563.38464400,2612.70849600,65.60421800,0.00000000,-90.24079544,267.28481143, .streamdistance = 500.0); //object(237)
		CreateDynamicObject(2395,-563.39196800,2614.69067400,62.74182900,0.00000000,0.00000000,-91.10023213, .streamdistance = 500.0); //object(238)
		CreateDynamicObject(4724,-561.92736800,2620.96069300,66.53112800,0.00000000,0.00000000,177.90373916, .streamdistance = 500.0); //object(239)
		CreateDynamicObject(1778,-560.23095700,2617.93920900,52.61386900,0.00000000,0.00000000,0.00000000, .streamdistance = 500.0); //object(242)
		CreateDynamicObject(1736,-563.63690200,2614.04418900,67.82275400,0.00000000,0.00000000,-94.53797890, .streamdistance = 500.0); //object(243)
		CreateDynamicObject(2395,-561.39648400,2615.26489300,65.09197200,0.00000000,-89.38135874,85.08417528, .streamdistance = 500.0); //object(246)
		CreateDynamicObject(2599,-560.49902300,2613.96899400,65.08065800,0.00000000,0.00000000,86.80304867, .streamdistance = 500.0); //object(247)
		CreateDynamicObject(3850,-567.24054000,2615.62670900,69.57921600,0.00000000,0.00000000,-1.71887339, .streamdistance = 500.0); //object(248)
		CreateDynamicObject(3850,-567.16192600,2619.09741200,69.57921600,0.00000000,0.00000000,-0.85943669, .streamdistance = 500.0); //object(249)
		CreateDynamicObject(3850,-567.29290800,2612.17187500,69.57921600,0.00000000,0.00000000,0.00000000, .streamdistance = 500.0); //object(250)
		CreateDynamicObject(3850,-560.99426300,2634.47338900,65.16284900,0.00000000,0.00000000,86.80304867, .streamdistance = 500.0); //object(251)
		CreateDynamicObject(3850,-557.59429900,2634.28881800,65.16284900,0.00000000,0.00000000,86.80304867, .streamdistance = 500.0); //object(253)
		CreateDynamicObject(3850,-554.18841600,2634.09594700,65.16284900,0.00000000,0.00000000,86.80304867, .streamdistance = 500.0); //object(254)
		CreateDynamicObject(3850,-550.81158400,2633.91870100,65.16284900,0.00000000,0.00000000,86.80304867, .streamdistance = 500.0); //object(255)
		CreateDynamicObject(644,-561.63653600,2633.78955100,64.92597200,0.00000000,0.00000000,0.00000000, .streamdistance = 500.0); //object(256)
		CreateDynamicObject(644,-556.71759000,2633.47631800,64.85096700,0.00000000,0.00000000,227.75083816, .streamdistance = 500.0); //object(257)
		CreateDynamicObject(644,-551.80053700,2633.23754900,64.85096700,0.00000000,0.00000000,152.97990319, .streamdistance = 500.0); //object(258)
		CreateDynamicObject(4892,-483.97341900,2568.20483400,54.39522200,0.00000000,0.00000000,-2.57831008, .streamdistance = 500.0); //object(243)
		CreateDynamicObject(1616,-478.14715600,2582.51074200,56.59251400,0.00000000,14.61042378,-87.66248536, .streamdistance = 500.0); //object(244)
		CreateDynamicObject(1633,-554.45159900,2581.73486300,65.77406300,0.00000000,0.00000000,-89.38135874, .streamdistance = 500.0); //object(249)
		CreateDynamicObject(1634,-555.04534900,2604.96777300,65.72108500,0.00000000,0.00000000,-89.38135874, .streamdistance = 500.0); //object(250)
		CreateDynamicObject(973,-479.86795000,2560.95263700,53.00136900,0.00000000,0.00000000,86.80304867, .streamdistance = 500.0); //object(251)
		CreateDynamicObject(12957,-488.73266600,2555.38574200,53.39384100,0.00000000,0.00000000,-148.68266243, .streamdistance = 500.0); //object(253)
		CreateDynamicObject(1217,-491.16235400,2555.15795900,53.13701600,180.48204924,0.00000000,0.00000000, .streamdistance = 500.0); //object(254)
		CreateDynamicObject(3461,-491.20455900,2555.17504900,51.89210500,0.00000000,0.00000000,0.00000000, .streamdistance = 500.0); //object(255)
		CreateDynamicObject(3286,-481.25479100,2555.60253900,51.89391700,0.00000000,0.00000000,0.00000000, .streamdistance = 500.0); //object(259)
		CreateDynamicObject(3286,-484.16729700,2553.09545900,52.05993300,0.00000000,0.00000000,0.00000000, .streamdistance = 500.0); //object(260)
		CreateDynamicObject(14467,-555.73968500,2628.89184600,66.92571300,0.00000000,0.00000000,85.94372657, .streamdistance = 500.0); //object(263)
		CreateDynamicObject(679,-556.14465300,2628.60937500,67.61273200,0.85943669,-15.46986047,2.57831008, .streamdistance = 500.0); //object(266)
		CreateDynamicObject(2811,-556.22900400,2628.63769500,67.42274500,0.00000000,0.00000000,0.00000000, .streamdistance = 500.0); //object(274)
		CreateDynamicObject(2249,-556.41784700,2627.30078100,69.69072000,-7.73493023,-26.64253747,84.22473859, .streamdistance = 500.0); //object(275)
		CreateDynamicObject(2250,-554.28411900,2629.52026400,67.95660400,299.94329116,102.27290914,31.79915763, .streamdistance = 500.0); //object(276)
	}
	return 1;
}

public OnGameModeExit()
{
	return 1;
}

public OnPlayerRequestClass(playerid, classid)
{
	SetPlayerPos(playerid, 1958.3783, 1343.1572, 15.3746);
	SetPlayerCameraPos(playerid, 1958.3783, 1343.1572, 15.3746);
	SetPlayerCameraLookAt(playerid, 1958.3783, 1343.1572, 15.3746);
	return 1;
}

public OnPlayerConnect(playerid)
{
	return 1;
}

public OnPlayerDisconnect(playerid, reason)
{
	return 1;
}

public OnPlayerSpawn(playerid)
{
	return 1;
}

public OnPlayerDeath(playerid, killerid, reason)
{
	return 1;
}

public OnVehicleSpawn(vehicleid)
{
	return 1;
}

public OnVehicleDeath(vehicleid, killerid)
{
	return 1;
}

public OnPlayerText(playerid, text[])
{
	return 1;
}

/*public OnPlayerCommandText(playerid, cmdtext[])
{
	if (strcmp("/mycommand", cmdtext, true, 10) == 0)
	{
		// Do something here
		return 1;
	}
	return 0;
}*/

public OnPlayerEnterVehicle(playerid, vehicleid, ispassenger)
{
	return 1;
}

public OnPlayerExitVehicle(playerid, vehicleid)
{
	return 1;
}

public OnPlayerStateChange(playerid, newstate, oldstate)
{
	return 1;
}

public OnPlayerEnterCheckpoint(playerid)
{
	return 1;
}

public OnPlayerLeaveCheckpoint(playerid)
{
	return 1;
}

public OnPlayerEnterRaceCheckpoint(playerid)
{
	return 1;
}

public OnPlayerLeaveRaceCheckpoint(playerid)
{
	return 1;
}

public OnRconCommand(cmd[])
{
	return 1;
}

public OnPlayerRequestSpawn(playerid)
{
	return 1;
}

public OnObjectMoved(objectid)
{
	return 1;
}

public OnPlayerObjectMoved(playerid, objectid)
{
	return 1;
}

public OnPlayerPickUpPickup(playerid, pickupid)
{
	return 1;
}

public OnVehicleMod(playerid, vehicleid, componentid)
{
	return 1;
}

public OnVehiclePaintjob(playerid, vehicleid, paintjobid)
{
	return 1;
}

public OnVehicleRespray(playerid, vehicleid, color1, color2)
{
	return 1;
}

public OnPlayerSelectedMenuRow(playerid, row)
{
	return 1;
}

public OnPlayerExitedMenu(playerid)
{
	return 1;
}

public OnPlayerInteriorChange(playerid, newinteriorid, oldinteriorid)
{
	return 1;
}

public OnPlayerKeyStateChange(playerid, newkeys, oldkeys)
{
	return 1;
}

public OnRconLoginAttempt(ip[], password[], success)
{
	return 1;
}

public OnPlayerUpdate(playerid)
{
	return 1;
}

public OnPlayerStreamIn(playerid, forplayerid)
{
	return 1;
}

public OnPlayerStreamOut(playerid, forplayerid)
{
	return 1;
}

public OnVehicleStreamIn(vehicleid, forplayerid)
{
	return 1;
}

public OnVehicleStreamOut(vehicleid, forplayerid)
{
	return 1;
}

public OnDialogResponse(playerid, dialogid, response, listitem, inputtext[])
{
	return 1;
}

public OnPlayerClickPlayer(playerid, clickedplayerid, source)
{
	return 1;
}
